Gradient Legend in JavaScript

Using ApexCharts with JavaScript

This Gradient Legend example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Seeded PRNG so the heatmap is identical on every load (stable snapshots).
var __seed = 0x33c4e5f6
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

function generateData(count, yrange) {
  var i = 0
  var series = []
  while (i < count) {
    var x = (i + 1).toString()
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min

    series.push({
      x: x,
      y: y,
    })
    i++
  }
  return series
}

var options = {
  series: [
    {
      name: 'Jan',
      data: generateData(18, { min: 0, max: 90 }),
    },
    {
      name: 'Feb',
      data: generateData(18, { min: 10, max: 90 }),
    },
    {
      name: 'Mar',
      data: generateData(18, { min: 20, max: 100 }),
    },
    {
      name: 'Apr',
      data: generateData(18, { min: 10, max: 100 }),
    },
    {
      name: 'May',
      data: generateData(18, { min: 0, max: 50 }),
    },
    {
      name: 'Jun',
      data: generateData(18, { min: 0, max: 90 }),
    },
    {
      name: 'Jul',
      data: generateData(18, { min: 0, max: 90 }),
    },
    {
      name: 'Aug',
      data: generateData(18, { min: 0, max: 90 }),
    },
    {
      name: 'Sep',
      data: generateData(18, { min: 0, max: 90 }),
    },
    {
      name: 'Oct',
      data: generateData(18, { min: 0, max: 90 }),
    },
    {
      name: 'Nov',
      data: generateData(18, { min: 0, max: 90 }),
    },
    {
      name: 'Dec',
      data: generateData(18, { min: 0, max: 90 }),
    },
  ],
  chart: {
    height: 380,
    type: 'heatmap',
  },
  plotOptions: {
    heatmap: {
      shadeIntensity: 0.5,
      radius: 2,
      useFillColorAsStroke: false,
      colorScale: {
        // Continuous gradient legend replaces the default categorical legend.
        // The arrow tracks the hovered cell's value along the spectrum and
        // automatically reorients based on legend.position.
        gradientLegend: {
          enabled: true,
          width: '75%',
          thickness: 14,
          showHoverValue: true,
        },
      },
    },
  },
  colors: ['#008FFB'],
  dataLabels: {
    enabled: false,
  },
  stroke: {
    width: 1,
  },
  legend: {
    position: 'right',
  },
  title: {
    text: 'Monthly Rainfall (mm) — continuous gradient legend',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Gradient Legend in Vue

Using ApexCharts with Vue

This Gradient Legend example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="heatmap"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Seeded PRNG so the heatmap is identical on every load (stable snapshots).
var __seed = 0x33c4e5f6
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

function generateData(count, yrange) {
  var i = 0
  var series = []
  while (i < count) {
    var x = (i + 1).toString()
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min

    series.push({
      x: x,
      y: y,
    })
    i++
  }
  return series
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Jan',
          data: generateData(18, { min: 0, max: 90 }),
        },
        {
          name: 'Feb',
          data: generateData(18, { min: 10, max: 90 }),
        },
        {
          name: 'Mar',
          data: generateData(18, { min: 20, max: 100 }),
        },
        {
          name: 'Apr',
          data: generateData(18, { min: 10, max: 100 }),
        },
        {
          name: 'May',
          data: generateData(18, { min: 0, max: 50 }),
        },
        {
          name: 'Jun',
          data: generateData(18, { min: 0, max: 90 }),
        },
        {
          name: 'Jul',
          data: generateData(18, { min: 0, max: 90 }),
        },
        {
          name: 'Aug',
          data: generateData(18, { min: 0, max: 90 }),
        },
        {
          name: 'Sep',
          data: generateData(18, { min: 0, max: 90 }),
        },
        {
          name: 'Oct',
          data: generateData(18, { min: 0, max: 90 }),
        },
        {
          name: 'Nov',
          data: generateData(18, { min: 0, max: 90 }),
        },
        {
          name: 'Dec',
          data: generateData(18, { min: 0, max: 90 }),
        },
      ],
      chartOptions: {
        chart: {
          height: 380,
          type: 'heatmap',
        },
        plotOptions: {
          heatmap: {
            shadeIntensity: 0.5,
            radius: 2,
            useFillColorAsStroke: false,
            colorScale: {
              // Continuous gradient legend replaces the default categorical legend.
              // The arrow tracks the hovered cell's value along the spectrum and
              // automatically reorients based on legend.position.
              gradientLegend: {
                enabled: true,
                width: '75%',
                thickness: 14,
                showHoverValue: true,
              },
            },
          },
        },
        colors: ['#008FFB'],
        dataLabels: {
          enabled: false,
        },
        stroke: {
          width: 1,
        },
        legend: {
          position: 'right',
        },
        title: {
          text: 'Monthly Rainfall (mm) — continuous gradient legend',
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Gradient Legend in React

Using ApexCharts with React

This Gradient Legend example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Seeded PRNG so the heatmap is identical on every load (stable snapshots).
var __seed = 0x33c4e5f6
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

function generateData(count, yrange) {
  var i = 0
  var series = []
  while (i < count) {
    var x = (i + 1).toString()
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min

    series.push({
      x: x,
      y: y,
    })
    i++
  }
  return series
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Jan',
        data: generateData(18, { min: 0, max: 90 }),
      },
      {
        name: 'Feb',
        data: generateData(18, { min: 10, max: 90 }),
      },
      {
        name: 'Mar',
        data: generateData(18, { min: 20, max: 100 }),
      },
      {
        name: 'Apr',
        data: generateData(18, { min: 10, max: 100 }),
      },
      {
        name: 'May',
        data: generateData(18, { min: 0, max: 50 }),
      },
      {
        name: 'Jun',
        data: generateData(18, { min: 0, max: 90 }),
      },
      {
        name: 'Jul',
        data: generateData(18, { min: 0, max: 90 }),
      },
      {
        name: 'Aug',
        data: generateData(18, { min: 0, max: 90 }),
      },
      {
        name: 'Sep',
        data: generateData(18, { min: 0, max: 90 }),
      },
      {
        name: 'Oct',
        data: generateData(18, { min: 0, max: 90 }),
      },
      {
        name: 'Nov',
        data: generateData(18, { min: 0, max: 90 }),
      },
      {
        name: 'Dec',
        data: generateData(18, { min: 0, max: 90 }),
      },
    ],
    options: {
      chart: {
        height: 380,
        type: 'heatmap',
      },
      plotOptions: {
        heatmap: {
          shadeIntensity: 0.5,
          radius: 2,
          useFillColorAsStroke: false,
          colorScale: {
            // Continuous gradient legend replaces the default categorical legend.
            // The arrow tracks the hovered cell's value along the spectrum and
            // automatically reorients based on legend.position.
            gradientLegend: {
              enabled: true,
              width: '75%',
              thickness: 14,
              showHoverValue: true,
            },
          },
        },
      },
      colors: ['#008FFB'],
      dataLabels: {
        enabled: false,
      },
      stroke: {
        width: 1,
      },
      legend: {
        position: 'right',
      },
      title: {
        text: 'Monthly Rainfall (mm) — continuous gradient legend',
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="heatmap"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart

Gradient Legend in Angular

Using ApexCharts with Angular

This Gradient Legend example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Jan',
              data: generateData(18, { min: 0, max: 90 }),
            },
            {
              name: 'Feb',
              data: generateData(18, { min: 10, max: 90 }),
            },
            {
              name: 'Mar',
              data: generateData(18, { min: 20, max: 100 }),
            },
            {
              name: 'Apr',
              data: generateData(18, { min: 10, max: 100 }),
            },
            {
              name: 'May',
              data: generateData(18, { min: 0, max: 50 }),
            },
            {
              name: 'Jun',
              data: generateData(18, { min: 0, max: 90 }),
            },
            {
              name: 'Jul',
              data: generateData(18, { min: 0, max: 90 }),
            },
            {
              name: 'Aug',
              data: generateData(18, { min: 0, max: 90 }),
            },
            {
              name: 'Sep',
              data: generateData(18, { min: 0, max: 90 }),
            },
            {
              name: 'Oct',
              data: generateData(18, { min: 0, max: 90 }),
            },
            {
              name: 'Nov',
              data: generateData(18, { min: 0, max: 90 }),
            },
            {
              name: 'Dec',
              data: generateData(18, { min: 0, max: 90 }),
            },
          ],
          chart: {
            height: 380,
            type: 'heatmap',
          },
          plotOptions: {
            heatmap: {
              shadeIntensity: 0.5,
              radius: 2,
              useFillColorAsStroke: false,
              colorScale: {
                // Continuous gradient legend replaces the default categorical legend.
                // The arrow tracks the hovered cell's value along the spectrum and
                // automatically reorients based on legend.position.
                gradientLegend: {
                  enabled: true,
                  width: '75%',
                  thickness: 14,
                  showHoverValue: true,
                },
              },
            },
          },
          colors: ['#008FFB'],
          dataLabels: {
            enabled: false,
          },
          stroke: {
            width: 1,
          },
          legend: {
            position: 'right',
          },
          title: {
            text: 'Monthly Rainfall (mm) — continuous gradient legend',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}